Index: /TOOLS/MOSAIX/RunoffWeights.py
===================================================================
--- /TOOLS/MOSAIX/RunoffWeights.py	(revision 6665)
+++ /TOOLS/MOSAIX/RunoffWeights.py	(revision 6666)
@@ -29,18 +29,50 @@
 ##
 ##
+'''Python code to generates weights for run-off. Launched by `CreateWeights.bash`.
+
+More information with python `RunOffWeights.py -h`.
+
+- Defines a coastal band on land in the atmosphere model. For LMDZ
+  rectilinear grids, the width of this band is parametrized, in grid
+  points. For ico grids, the band contains only point with a
+  fraction of ocean in ]0,1[.
+
+- Defines a coastal band on ocean in the ocean model. The width of
+  this band is parametrized.
+
+- An atmosphere point of the coastal band is linked to an ocean
+  point in the coastal band if the distance between the two is less
+  than searchRadius.
+
+## SVN information
+Author   = "$Author$"
+Date     = "$Date$"
+Revision = "$Revision$"
+Id       = "$Id$"
+HeadURL  = "$HeadURL$"
+'''
+
+## Modules
+import sys
+import os
+import platform
+import getpass
+import argparse
+import time
+import numpy as np
+import xarray as xr
+from scipy import ndimage
+import nemo
+
 # SVN information
-__Author__   = "$Author$"
-__Date__     = "$Date$"
-__Revision__ = "$Revision$"
-__Id__       = "$Id$"
-__HeadURL__  = "$HeadURL$"
-__SVN_Date__ = "$SVN_Date: $"
-##
-
-## Modules
-import numpy as np, xarray as xr
-import nemo
-from scipy import ndimage
-import sys, os, platform, argparse, textwrap, time
+__SVN__ = ({
+    'Author'   : '$Author$',
+    'Date'     : '$Date$',
+    'Revision' : '$Revision$',
+    'Id'       : '$Id$',
+    'HeadURL'  : '$HeadURL$',
+    'SVN_Date' : '$SVN_Date: $',
+    })
+##
 
 ## Useful constants
@@ -54,35 +86,48 @@
 ## Functions
 def geodist (plon1, plat1, plon2, plat2) :
-      """Distance between two points (on sphere)"""
-      zs = np.sin (rad*plat1) * np.sin (rad*plat2) +  np.cos (rad*plat1) * np.cos (rad*plat2) * np.cos(rad*(plon2-plon1))
-      zs = np.maximum (-zone, np.minimum (zone, zs))
-      geodist =  np.arccos (zs)
-      return geodist
+    '''Distance between two points (on sphere)'''
+    zs = ( np.sin (rad*plat1) * np.sin (rad*plat2) +
+           np.cos (rad*plat1) * np.cos (rad*plat2) * np.cos(rad*(plon2-plon1)) )
+    zs = np.maximum (-zone, np.minimum (zone, zs))
+    zgeodist =  np.arccos (zs)
+    return zgeodist
 
 ### ===== Reading command line parameters ==================================================
 # Creating a parser
 parser = argparse.ArgumentParser (
-    description = """Compute calving weights""",
+    description = '''Compute calving weights''',
     epilog='-------- End of the help message --------')
 
 # Adding arguments
 parser.add_argument ('--oce'          , help='oce model name', type=str, default='eORCA1.2',
-                         choices=['ORCA2.3',  'ORCA1.0', 'ORCA1.1', 'ORCA1_CNRM', 'eORCA1.2', 'eORCA1.4', 'eORCA1.4.2', 'eORCA025', 'eORCA025.1', 'eORCA025.4'] )
+                     choices=['ORCA2.3',  'ORCA1.0', 'ORCA1.1', 'ORCA1_CNRM', 'eORCA1.2',
+                              'eORCA1.4', 'eORCA1.4.2', 'eORCA025', 'eORCA025.1', 'eORCA025.4'] )
 parser.add_argument ('--atm'          , help='atm model name', type=str, default='LMD9695'    )
-parser.add_argument ('--atmCoastWidth', help='width of the coastal band in atmosphere (in grid points)', type=int, default=1 )
-parser.add_argument ('--oceCoastWidth', help='width of the coastal band in ocean (in grid points)'     , type=int, default=2 )
-parser.add_argument ('--atmQuantity'  , help='Quantity if atm provides quantities (m/s), Surfacic if atm provided flux (m/s/m2)' , type=str,
-                         default='Quantity', choices=['Quantity', 'Surfacic'] )
-parser.add_argument ('--oceQuantity'  , help='Quantity if oce requires quantities (ks/s), Surfacic if oce requires flux (m/s/m2)', type=str,
-                         default='Surfacic', choices=['Quantity', 'Surfacic'] )
-parser.add_argument ('--searchRadius' , help='max distance to connect a land point to an ocean point (in km)', type=float, default=600.0 )
+parser.add_argument ('--atmCoastWidth', type=int, default=1,
+                         help='width of the coastal band in atmosphere (in grid points)' )
+parser.add_argument ('--oceCoastWidth',
+                         help='width of the coastal band in ocean (in grid points)'     ,
+                         type=int, default=2 )
+parser.add_argument ('--atmQuantity'  , type=str, default='Quantity',
+                         choices=['Quantity', 'Surfacic'],
+                         help='Quantity if atm provides quantities (m/s), Surfacic if atm provided flux (m/s/m2)' )
+parser.add_argument ('--oceQuantity'  , type=str, default='Surfacic',
+                         choices=['Quantity', 'Surfacic'],
+                         help='Quantity if oce requires quantities (ks/s), Surfacic if oce requires flux (m/s/m2)' )
+parser.add_argument ('--searchRadius' , type=float, default=600.0,
+                         help='max distance to connect a land point to an ocean point (in km)' )
 parser.add_argument ('--grids' , help='grids file name', default='grids.nc' )
 parser.add_argument ('--areas' , help='masks file name', default='areas.nc' )
 parser.add_argument ('--masks' , help='areas file name', default='masks.nc' )
 parser.add_argument ('--o2a'   , help='o2a file name'  , default='o2a.nc'   )
-parser.add_argument ('--output', help='output rmp file name', default='rmp_tlmd_to_torc_runoff.nc' )
-parser.add_argument ('--fmt'   , help='NetCDF file format, using nco syntax', default='netcdf4',
-                         choices=['classic', 'netcdf3', '64bit', '64bit_data', '64bit_data', 'netcdf4', 'netcdf4_classsic'] )
-parser.add_argument ('--ocePerio'   , help='periodicity of ocean grid', type=float, default=0, choices=nemo.nperio_valid_range)
+parser.add_argument ('--output', help='output rmp file name',
+                         default='rmp_tlmd_to_torc_runoff.nc' )
+parser.add_argument ('--fmt'   , default='netcdf4',
+                         help='NetCDF file format, using nco syntax',
+                         choices=['classic', 'netcdf3', '64bit', '64bit_data',
+                                  '64bit_data', 'netcdf4', 'netcdf4_classsic'] )
+parser.add_argument ('--ocePerio' , help='periodicity of ocean grid', type=float,
+                         default=0, choices=nemo.NPERIO_VALID_RANGE)
+parser.add_argument ('--modelName' , help='Name of model', type=str, default=None)
 
 # Parse command line
@@ -96,9 +141,10 @@
 
 # Model Names
-atm_Name = myargs.atm
-oce_Name = myargs.oce
+atm_Name   = myargs.atm
+oce_Name   = myargs.oce
+model_name = myargs.modelName
 # Width of the coastal band (land points) in the atmopshere
 atmCoastWidth = myargs.atmCoastWidth
-# Width of the coastal band (ocean points) in the ocean 
+# Width of the coastal band (ocean points) in the ocean
 oceCoastWidth = myargs.oceCoastWidth
 searchRadius  = myargs.searchRadius * 1000.0 # From km to meters
@@ -152,5 +198,5 @@
     atm_grid_area       = atm_grid_area.rename  ({'ycell':'cell'})
     atm_grid_imask      = atm_grid_imask.rename ({'ycell':'cell'})
-    
+
 if atmDomainType == 'rectilinear' :
     atm_grid_center_lat = atm_grid_center_lat.stack (cell=['y', 'x'])
@@ -164,5 +210,4 @@
 atm_grid_pmask = atm_grid_imask
 
-
 atm_address = np.arange(atm_jpj*atm_jpi)
 
@@ -186,12 +231,14 @@
 #    if oce_jpi ==  362 : oce_perio = 6 # ORCA 1
 #    if oce_jpi == 1442 : oce_perio = 6 # ORCA 025
-oce_preio = nemo.__guessNperio__ (oce_jpj, oce_jpi, nperio=oce_perio)
-
-print ("Oce NPERIO parameter : {:}".format(oce_perio))
-oce_grid_imask = nemo.lbc      (np.reshape(oce_grid_imask.values, (oce_jpj,oce_jpi)), nperio=oce_perio, cd_type='T'        ).ravel()
-oce_grid_pmask = nemo.lbc_mask (np.reshape(oce_grid_imask       , (oce_jpj,oce_jpi)), nperio=oce_perio, cd_type='T', sval=0).ravel()
+oce_preio = nemo.__guess_nperio__ (oce_jpj, oce_jpi, nperio=oce_perio)
+
+print ( f'Oce NPERIO parameter : {oce_perio}' )
+oce_grid_imask = nemo.lbc      (np.reshape(oce_grid_imask.values, (oce_jpj,oce_jpi)),
+                                nperio=oce_perio, cd_type='T'        ).ravel()
+oce_grid_pmask = nemo.lbc_mask (np.reshape(oce_grid_imask       , (oce_jpj,oce_jpi)),
+                                nperio=oce_perio, cd_type='T', sval=0).ravel()
 oce_address = np.arange(oce_jpj*oce_jpi)
 
-print ("Fill closed seas with image processing library")
+print ('Fill closed seas with image processing library')
 oce_grid_imask2D = np.reshape (oce_grid_imask, (oce_jpj,oce_jpi))
 oce_grid_imask2D = 1-nemo.fill_closed_seas (1-oce_grid_imask2D, nperio=oce_perio, cd_type='T')
@@ -200,6 +247,6 @@
 oce_grid_imask = oce_grid_imask2D.ravel ()
 
-## 
-print ("Computes an ocean coastal band with image processing library")
+##
+print ('Computes an ocean coastal band with image processing library')
 oceLand2D  = np.reshape ( np.where (oce_grid_imask < 0.5, True, False), (oce_jpj, oce_jpi) )
 oceOcean2D = np.reshape ( np.where (oce_grid_imask > 0.5, True, False), (oce_jpj, oce_jpi) )
@@ -208,5 +255,6 @@
 oceOceanFiltered2D = ndimage.uniform_filter (oceOcean2D.astype(float), size=NNocean)
 oceCoast2D = np.where (oceOceanFiltered2D<(1.0-0.5/(NNocean**2)),True,False) & oceOcean2D
-oceCoast2D = nemo.lbc_mask (np.reshape(oceCoast2D, (oce_jpj,oce_jpi)), nperio=oce_perio, cd_type='T', sval=0.).ravel()
+oceCoast2D = nemo.lbc_mask (np.reshape(oceCoast2D, (oce_jpj,oce_jpi)),
+                            nperio=oce_perio, cd_type='T', sval=0.).ravel()
 
 oceOceanFiltered = oceOceanFiltered2D.ravel()
@@ -215,7 +263,7 @@
 oceCoast = oceCoast2D.ravel()
 
-print ('Number of points in oceLand  : {:8d}'.format (oceLand.sum())  )
-print ('Number of points in oceOcean : {:8d}'.format (oceOcean.sum()) )
-print ('Number of points in oceCoast : {:8d}'.format (oceCoast.sum()) )
+print ( f'Number of points in oceLand  : {oceLand.sum():8d}' )
+print ( f'Number of points in oceOcean : {oceOcean.sum():8d}' )
+print ( f'Number of points in oceCoast : {oceCoast.sum():8d}' )
 
 # Arrays with coastal points only
@@ -227,8 +275,9 @@
 oceCoast_address         = oce_address        [oceCoast]
 
-print ("Computes an atmosphere coastal band" )
+print ('Computes an atmosphere coastal band' )
 atmLand      = np.where (o2aFrac[:] < epsfrac       , True, False)
 atmLandFrac  = np.where (o2aFrac[:] < zone-epsfrac  , True, False)
-atmFrac      = np.where (o2aFrac[:] > epsfrac       , True, False) & np.where (o2aFrac[:] < (zone-epsfrac), True, False)
+atmFrac      = np.where (o2aFrac[:] > epsfrac       , True, False) & \
+                         np.where (o2aFrac[:] < (zone-epsfrac), True, False)
 atmOcean     = np.where (o2aFrac[:] < (zone-epsfrac), True, False)
 atmOceanFrac = np.where (o2aFrac[:] > epsfrac       , True, False)
@@ -236,5 +285,5 @@
 ## For LMDZ only !!
 if atmDomainType == 'rectilinear' :
-    print ("Extend coastal band " )
+    print ('Extend coastal band ' )
     NNatm = 1+2*atmCoastWidth
     atmLand2D = np.reshape ( atmLand, ( atm_jpj, atm_jpi) )
@@ -242,16 +291,16 @@
     atmLandFiltered2D = ndimage.uniform_filter(atmLand2D.astype(float), size=NNatm)
     atmCoast2D = np.where (atmLandFiltered2D<(1.0-0.5/(NNatm**2)),True,False) & atmLandFrac
-    
+
     atmLandFiltered = atmLandFiltered2D.ravel()
     atmCoast = atmCoast2D.ravel()
 
-    print ('Number of points in atmLand  : {:8d}'.format (atmLand.sum())  )
-    print ('Number of points in atmOcean : {:8d}'.format (atmOcean.sum()) )
-    print ('Number of points in atmCoast : {:8d}'.format (atmCoast.sum()) )
+    print ( f'Number of points in atmLand  : {atmLand.sum():8d}'  )
+    print ( f'Number of points in atmOcean : {atmOcean.sum():8d}' )
+    print ( f'Number of points in atmCoast : {atmCoast.sum():8d}' )
 
 else :
     atmCoast = atmFrac
-    
-    
+
+
 # Arrays with coastal points only
 atmCoast_grid_center_lon = atm_grid_center_lon[atmCoast]
@@ -269,7 +318,8 @@
 ## Loop on atmosphere coastal points
 if searchRadius > 0. :
-    print ("Loop on atmosphere coastal points")
+    print ('Loop on atmosphere coastal points')
     for ja in np.arange (len(atmCoast_grid_pmask)) :
-        z_dist = geodist ( atmCoast_grid_center_lon[ja], atmCoast_grid_center_lat[ja], oceCoast_grid_center_lon, oceCoast_grid_center_lat)
+        z_dist = geodist ( atmCoast_grid_center_lon[ja], atmCoast_grid_center_lat[ja],
+                               oceCoast_grid_center_lon, oceCoast_grid_center_lat)
         z_mask = np.where (z_dist*ra < searchRadius, True, False)
         num_links = int (z_mask.sum())
@@ -280,6 +330,6 @@
         if myargs.oceQuantity == 'Quantity' : poids = poids * oceCoast_grid_area[z_mask]
         if  ja % (len(atmCoast_grid_pmask)//50) == 0 : # Control print
-            print ( 'ja:{:8d}, num_links:{:8d},  z_area:{:8.4e},  atm area:{:8.4e},  weights sum:{:8.4e}  '
-                        .format(ja, num_links, z_area, atm_grid_area[ja].values, poids.sum() ) )
+            print ( f'ja:{ja:8d} num_links:{num_links:8d} z_area:{z_area:8.4e} '+
+                    f'atm area:{atm_grid_area[ja].values:8.4e} weights sum:{poids.sum():8.4e}' )
         #
         matrix_local = poids
@@ -296,81 +346,107 @@
 num_links = remap_matrix.shape[0]
 
-print ("Write output file")
+print ('Write output file')
 runoff = myargs.output
 print ('Output file: ' + runoff )
 
-
-remap_matrix = xr.DataArray ( np.reshape(remap_matrix, (num_links, 1)), dims = ['num_links', 'num_wgts'] )
+remap_matrix = xr.DataArray ( np.reshape(remap_matrix, (num_links, 1)),
+                                  dims = ['num_links', 'num_wgts'] )
 
 # OASIS uses Fortran style indexing, starting at one
 src_address  = xr.DataArray ( atm_address.astype(np.int32)+1, dims = ['num_links'],
-                                 attrs={"convention": "Fortran style addressing, starting at 1"}) 
+                                 attrs={'convention': 'Fortran style addressing, starting at 1'})
 dst_address  = xr.DataArray ( oce_address.astype(np.int32)+1, dims = ['num_links'],
-                                 attrs={"convention": "Fortran style addressing, starting at 1"})
-
-src_grid_dims       = xr.DataArray (np.array(atm_grid_dims, dtype=np.int32), dims = ['src_grid_rank',] )
+                                 attrs={'convention': 'Fortran style addressing, starting at 1'})
+
+src_grid_dims       = xr.DataArray (np.array(atm_grid_dims, dtype=np.int32),
+                                        dims = ['src_grid_rank',] )
 src_grid_center_lon = xr.DataArray (atm_grid_center_lon.values , dims = ['src_grid_size',] )
 src_grid_center_lat = xr.DataArray (atm_grid_center_lat.values , dims = ['src_grid_size',] )
 
-src_grid_center_lon.attrs['units']='degrees_east'  ; src_grid_center_lon.attrs['long_name']='Longitude'
-src_grid_center_lon.attrs['long_name']='longitude' ; src_grid_center_lon.attrs['bounds']="src_grid_corner_lon"
-src_grid_center_lat.attrs['units']='degrees_north' ; src_grid_center_lat.attrs['long_name']='Latitude'
-src_grid_center_lat.attrs['long_name']='latitude ' ; src_grid_center_lat.attrs['bounds']="src_grid_corner_lat"
- 
-src_grid_corner_lon = xr.DataArray (atm_grid_corner_lon.values.transpose(), dims = [ 'src_grid_size', 'src_grid_corners'] )
-src_grid_corner_lat = xr.DataArray (atm_grid_corner_lat.values.transpose(), dims = [ 'src_grid_size', 'src_grid_corners'] )
-src_grid_corner_lon.attrs['units']="degrees_east"
-src_grid_corner_lat.attrs['units']="degrees_north"
-
-src_grid_area       =  xr.DataArray (atm_grid_area.values, dims = ['src_grid_size',] ) 
-src_grid_area.attrs['long_name']="Grid area" ; src_grid_area.attrs['standard_name']="cell_area" ; src_grid_area.attrs['units']="m2"
-
-src_grid_imask      =  xr.DataArray (atm_grid_imask.values, dims = ['src_grid_size',] ) 
-src_grid_imask.attrs['long_name']="Land-sea mask" ; src_grid_imask.attrs['units']="Land:1, Ocean:0"
-
-src_grid_pmask      =  xr.DataArray (atm_grid_pmask.values, dims = ['src_grid_size',] ) 
-src_grid_pmask.attrs['long_name']="Land-sea mask (periodicity removed)" ; src_grid_pmask.attrs['units']="Land:1, Ocean:0"
+src_grid_center_lon.attrs.update ( {'units':'degrees_east' , 'long_name':'Longitude',
+                                        'standard_name':'longitude',
+                                        'bounds':'src_grid_corner_lon'} )
+src_grid_center_lat.attrs.update ( {'units':'degrees_north', 'long_name':'Latitude' ,
+                                        'standard_name':'latitude' ,
+                                        'bounds':'src_grid_corner_lat'} )
+
+src_grid_corner_lon = xr.DataArray (atm_grid_corner_lon.values.transpose(),
+                                        dims = [ 'src_grid_size', 'src_grid_corners'] )
+src_grid_corner_lat = xr.DataArray (atm_grid_corner_lat.values.transpose(),
+                                        dims = [ 'src_grid_size', 'src_grid_corners'] )
+src_grid_corner_lon.attrs['units']='degrees_east'
+src_grid_corner_lat.attrs['units']='degrees_north'
+
+src_grid_area       =  xr.DataArray (atm_grid_area.values, dims = ['src_grid_size',] )
+src_grid_area.attrs.update ( {'long_name':'Grid area', 'standard_name':'cell_area',
+                                  'units':'m2' } )
+src_grid_imask      =  xr.DataArray (atm_grid_imask.values, dims = ['src_grid_size',] )
+src_grid_imask.attrs.update ( {'long_name':'Land-sea mask', 'units':'Land:1, Ocean:0'} )
+
+src_grid_pmask      =  xr.DataArray (atm_grid_pmask.values, dims = ['src_grid_size',] )
+src_grid_pmask.attrs.update ( {'long_name':'Land-sea mask (periodicity removed)',
+                                   'units':'Land:1, Ocean:0' } )
 
 # --
-dst_grid_dims       = xr.DataArray (np.array(oce_grid_dims, dtype=np.int32), dims = ['dst_grid_rank',] )
+dst_grid_dims       = xr.DataArray (np.array(oce_grid_dims, dtype=np.int32),
+                                        dims = ['dst_grid_rank',] )
 dst_grid_center_lon = xr.DataArray (oce_grid_center_lon.values, dims = ['dst_grid_size',] )
 dst_grid_center_lat = xr.DataArray (oce_grid_center_lat.values, dims = ['dst_grid_size',] )
 
-dst_grid_center_lon.attrs['units']='degrees_east'  ; dst_grid_center_lon.attrs['long_name']='Longitude'
-dst_grid_center_lon.attrs['long_name']='longitude' ; dst_grid_center_lon.attrs['bounds']="dst_grid_corner_lon"
-dst_grid_center_lat.attrs['units']='degrees_north' ; dst_grid_center_lat.attrs['long_name']='Latitude'
-dst_grid_center_lat.attrs['long_name']='latitude ' ; dst_grid_center_lat.attrs['bounds']="dst_grid_corner_lat"
-
-dst_grid_corner_lon = xr.DataArray (np.transpose(oce_grid_corner_lon.values), dims = [ 'dst_grid_size', 'dst_grid_corners'] )
-dst_grid_corner_lat = xr.DataArray (np.transpose(oce_grid_corner_lat.values), dims = [ 'dst_grid_size', 'dst_grid_corners'] )
-dst_grid_corner_lon.attrs['units']="degrees_east"
-dst_grid_corner_lat.attrs['units']="degrees_north"
-
-dst_grid_area       =  xr.DataArray (oce_grid_area.values, dims = ['dst_grid_size',] ) 
-dst_grid_area.attrs['long_name']="Grid area" ; dst_grid_area.attrs['standard_name']="cell_area" ; dst_grid_area.attrs['units']="m2"
-
-dst_grid_imask      =  xr.DataArray (oce_grid_imask.astype(np.int32), dims = ['dst_grid_size',] ) 
-dst_grid_imask.attrs['long_name']="Land-sea mask" ; dst_grid_imask.attrs['units']="Land:1, Ocean:0"
-
-dst_grid_pmask      =  xr.DataArray (oce_grid_pmask, dims = ['dst_grid_size',] ) 
-dst_grid_pmask.attrs['long_name']="Land-sea mask (periodicity removed)" ; dst_grid_pmask.attrs['units']="Land:1, Ocean:0"
-
-src_lon_addressed   =  xr.DataArray (atm_grid_center_lon.values[atm_address]                  , dims = ['num_links'] )
-src_lat_addressed   =  xr.DataArray (atm_grid_center_lat.values[atm_address]                  , dims = ['num_links'] )
-src_area_addressed  =  xr.DataArray (atm_grid_area      .values[atm_address]                  , dims = ['num_links'] )
-src_imask_addressed =  xr.DataArray (1-atm_grid_imask   .values[atm_address].astype(np.int32) , dims = ['num_links'] )
-src_pmask_addressed =  xr.DataArray (1-atm_grid_pmask   .values[atm_address].astype(np.int32) , dims = ['num_links'] )
-
-dst_lon_addressed   =  xr.DataArray (oce_grid_center_lon.values[atm_address], dims = ['num_links'] )
-dst_lat_addressed   =  xr.DataArray (oce_grid_center_lat.values[oce_address], dims = ['num_links'] )
-dst_area_addressed  =  xr.DataArray (oce_grid_area.values[oce_address].astype(np.int32)      , dims = ['num_links'] )
-dst_imask_addressed =  xr.DataArray (1-oce_grid_imask[oce_address].astype(np.int32)   , dims = ['num_links'] )
-dst_pmask_addressed =  xr.DataArray (1-oce_grid_pmask[oce_address].astype(np.int32)   , dims = ['num_links'] )
-
-src_lon_addressed.attrs['long_name']="Longitude" ; src_lon_addressed.attrs['standard_name']="longitude" ; src_lon_addressed.attrs['units']="degrees_east"
-src_lat_addressed.attrs['long_name']="Latitude"  ; src_lat_addressed.attrs['standard_name']="latitude"  ; src_lat_addressed.attrs['units']="degrees_north"
-
-dst_lon_addressed.attrs['long_name']="Longitude" ; dst_lon_addressed.attrs['standard_name']="longitude" ; dst_lon_addressed.attrs['units']="degrees_east"
-dst_lat_addressed.attrs['long_name']="Latitude"  ; dst_lat_addressed.attrs['standard_name']="latitude"  ; dst_lat_addressed.attrs['units']="degrees_north"
+dst_grid_center_lon.attrs.update ( {'units':'degrees_east' , 'long_name':'Longitude',
+                                        'standard_name':'longitude',
+                                        'bounds':'dst_grid_corner_lon' } )
+dst_grid_center_lat.attrs.update ( {'units':'degrees_north', 'long_name':'Latitude' ,
+                                        'standard_name':'latitude' ,
+                                        'bounds':'dst_grid_corner_lat' } )
+
+dst_grid_corner_lon = xr.DataArray (np.transpose(oce_grid_corner_lon.values),
+                                        dims = [ 'dst_grid_size', 'dst_grid_corners'] )
+dst_grid_corner_lat = xr.DataArray (np.transpose(oce_grid_corner_lat.values),
+                                        dims = [ 'dst_grid_size', 'dst_grid_corners'] )
+dst_grid_corner_lon.attrs['units']='degrees_east'
+dst_grid_corner_lat.attrs['units']='degrees_north'
+
+dst_grid_area       =  xr.DataArray (oce_grid_area.values, dims = ['dst_grid_size',] )
+dst_grid_area.attrs.update ( {'long_name':'Grid area', 'standard_name':'cell_area', 'units':'m2' })
+
+dst_grid_imask      =  xr.DataArray (oce_grid_imask.astype(np.int32), dims = ['dst_grid_size',] )
+dst_grid_imask.attrs.update ( {'long_name':'Land-sea mask', 'units':'Land:1, Ocean:0'} )
+
+dst_grid_pmask      =  xr.DataArray (oce_grid_pmask, dims = ['dst_grid_size',] )
+dst_grid_pmask.attrs.update ( {'long_name':'Land-sea mask (periodicity removed)',
+                                   'units':'Land:1, Ocean:0'} )
+
+src_lon_addressed   =  xr.DataArray (atm_grid_center_lon.values[atm_address] ,
+                                         dims = ['num_links'] )
+src_lat_addressed   =  xr.DataArray (atm_grid_center_lat.values[atm_address] ,
+                                         dims = ['num_links'] )
+src_area_addressed  =  xr.DataArray (atm_grid_area      .values[atm_address] ,
+                                         dims = ['num_links'] )
+src_imask_addressed =  xr.DataArray (1-atm_grid_imask   .values[atm_address].astype(np.int32) ,
+                                         dims = ['num_links'] )
+src_pmask_addressed =  xr.DataArray (1-atm_grid_pmask   .values[atm_address].astype(np.int32) ,
+                                         dims = ['num_links'] )
+
+dst_lon_addressed   =  xr.DataArray (oce_grid_center_lon.values[atm_address],
+                                         dims = ['num_links'] )
+dst_lat_addressed   =  xr.DataArray (oce_grid_center_lat.values[oce_address],
+                                         dims = ['num_links'] )
+dst_area_addressed  =  xr.DataArray (oce_grid_area.values[oce_address].astype(np.int32) ,
+                                         dims = ['num_links'] )
+dst_imask_addressed =  xr.DataArray (1-oce_grid_imask[oce_address].astype(np.int32)   ,
+                                         dims = ['num_links'] )
+dst_pmask_addressed =  xr.DataArray (1-oce_grid_pmask[oce_address].astype(np.int32)   ,
+                                         dims = ['num_links'] )
+
+src_lon_addressed.attrs.update ({'units':'degrees_east' , 'long_name':'Longitude',
+                                     'standard_name':'longitude' })
+src_lat_addressed.attrs.update ({'units':'degrees_north', 'long_name':'Latitude' ,
+                                     'standard_name':'latitude'  })
+
+dst_lon_addressed.attrs.update ({'units':'degrees_east' , 'long_name':'Longitude',
+                                     'standard_name':'longitude' })
+dst_lat_addressed.attrs.update ({'units':'degrees_north', 'long_name':'Latitude' ,
+                                     'standard_name':'latitude'  })
 
 if atmDomainType == 'rectilinear' :
@@ -390,5 +466,5 @@
 
 f_runoff = xr.Dataset ( {
-    'remap_matrix'            : remap_matrix,
+    'remap_matrix'        : remap_matrix,
 	'src_address'         : src_address,
 	'dst_address'         : dst_address,
@@ -398,5 +474,4 @@
     'src_grid_corner_lon' : src_grid_corner_lon,
     'src_grid_corner_lat' : src_grid_corner_lat,
-	'src_grid_area'       : src_grid_area,
 	'src_grid_area'       : src_grid_area,
 	'src_grid_imask'      : src_grid_imask,
@@ -425,47 +500,42 @@
     } )
 
-f_runoff.attrs['Conventions']     = "CF-1.6"
-f_runoff.attrs['source']          = "IPSL Earth system model"
-f_runoff.attrs['group']           = "ICMC IPSL Climate Modelling Center"
-f_runoff.attrs['Institution']     = "IPSL https.//www.ipsl.fr"
-f_runoff.attrs['Ocean']           = oce_Name + " https://www.nemo-ocean.eu"
-f_runoff.attrs['Atmosphere']      = atm_Name + " http://lmdz.lmd.jussieu.fr"
-f_runoff.attrs['associatedFiles'] = grids + " " + areas + " " + masks
-f_runoff.attrs['description']     = "Generated with RunoffWeights.py"
-f_runoff.attrs['title']           = runoff
-f_runoff.attrs['Program']         = "Generated by " + sys.argv[0] + " with flags " + ' '.join (sys.argv[1:]) 
-f_runoff.attrs['atmCoastWidth']   = "{:d} grid points".format(atmCoastWidth)
-f_runoff.attrs['oceCoastWidth']   = "{:d} grid points".format(oceCoastWidth)
-f_runoff.attrs['searchRadius']    = "{:.0f} km".format(searchRadius/1000.)
-f_runoff.attrs['atmQuantity']     = myargs.atmQuantity
-f_runoff.attrs['oceQuantity']     = myargs.oceQuantity
-f_runoff.attrs['gridsFile']       = grids
-f_runoff.attrs['areasFile']       = areas
-f_runoff.attrs['masksFile']       = masks
-f_runoff.attrs['o2aFile']         = o2a
-f_runoff.attrs['timeStamp']       = time.asctime ()
-try    : f_calving.attrs['directory'] = os.getcwd ()
-except : pass
-try    : f_runoff.attrs['HOSTNAME'] = platform.node ()
-except : pass
-try    : f_runoff.attrs['LOGNAME']  = os.getlogin ()
-except : pass
-try    : f_runoff.attrs['Python']   = "Python version " +  platform.python_version ()
-except : pass
-try    : f_runoff.attrs['OS']       = platform.system ()
-except : pass
-try    : f_runoff.attrs['release']  = platform.release ()
-except : pass
-try    : f_runoff.attrs['hardware'] = platform.machine ()
-except : pass
-f_runoff.attrs['conventions']     = "SCRIP"
-f_runoff.attrs['source_grid']     = "curvilinear"
-f_runoff.attrs['dest_grid']       = "curvilinear"
-f_runoff.attrs['Model']           = "IPSL CM6"
-f_runoff.attrs['SVN_Author']      = "$Author$"
-f_runoff.attrs['SVN_Date']        = "$Date$"
-f_runoff.attrs['SVN_Revision']    = "$Revision$"
-f_runoff.attrs['SVN_Id']          = "$Id$"
-f_runoff.attrs['SVN_HeadURL']     = "$HeadURL$"
+f_runoff.attrs.update ( {
+    'Conventions'     : 'CF-1.6',
+    'source'          : 'IPSL Earth system model',
+    'group'           : 'ICMC IPSL Climate Modelling Center',
+    'Institution'     : 'IPSL https.//www.ipsl.fr',
+    'Ocean'           : f'{oce_Name} https://www.nemo-ocean.eu',
+    'Atmosphere'      : f'{atm_Name} http://lmdz.lmd.jussieu.fr',
+    'associatedFiles' : f'{grids} {areas} {masks}',
+    'description'     : 'Generated with RunoffWeights.py',
+    'title'           : runoff,
+    'Program'         : f'Generated by {sys.argv[0]} with flags ' + ' '.join (sys.argv[1:]),
+    'atmCoastWidth'   : f'{atmCoastWidth:d} grid points',
+    'oceCoastWidth'   : f'{oceCoastWidth:d} grid points',
+    'searchRadius'    : f'{searchRadius/1000.:.0f} km',
+    'atmQuantity'     : myargs.atmQuantity,
+    'oceQuantity'     : myargs.oceQuantity,
+    'gridsFile'       : grids,
+    'areasFile'       : areas,
+    'masksFile'       : masks,
+    'o2aFile'         : o2a,
+    'timeStamp'       : time.asctime (),
+    'directory'       : os.getcwd (),
+    'HOSTNAME'        : platform.node (),
+    'LOGNAME'         : getpass.getuser(),
+    'Python'          : f'Python version {platform.python_version ()}',
+    'OS'              : platform.system (),
+    'release'         : platform.release (),
+    'hardware'        : platform.machine (),
+    'conventions'     : 'SCRIP',
+    'source_grid'     : 'curvilinear',
+    'dest_grid'       : 'curvilinear',
+    'Model'           : model_name,
+    'SVN_Author'      : '$Author$',
+    'SVN_Date'        : '$Date$',
+    'SVN_Revision'    : '$Revision$',
+    'SVN_Id'          : '$Id$',
+    'SVN_HeadURL'     : '$HeadURL$',
+    } )
 
 f_runoff.to_netcdf ( runoff, mode='w', format=FmtNetcdf )
@@ -474,4 +544,4 @@
 ##
 
-print ('That''s all folks !')
+print ("That''s all folks !")
 ## ======================================================================================
